/**
 * The main entry point: Babel preset for `twstyled` based on Linaria and xwind
 *
 * A preset is used to force the plugin order for Babel and to set default plugin options
 */
import type { ConfigAPI } from '@babel/core';
import plugin from './plugin';
import { CorePluginOptions } from './types';
export default function (babel: ConfigAPI, options: CorePluginOptions): {
    plugins?: undefined;
} | {
    plugins: (typeof plugin | {
        classNameSlug?: string | ((hash: string, title: string) => string) | undefined;
        displayName: boolean;
        evaluate: boolean;
        ignore?: RegExp | undefined;
        babelOptions?: import("@babel/core").TransformOptions | undefined;
        rules: import("@linaria/babel-preset/types").EvalRule[] | {
            action: any;
        }[];
        importMap: {
            [key: string]: string[];
            css: string[];
            styled: string[];
        } | {
            styled: string[];
            css: string[];
            tw: string[];
        };
        templateProcessor?: import("@linaria/babel-preset/types").TemplateProcessor | undefined;
        sourceMap: boolean;
        cacheDirectory?: string | undefined;
        preprocessor?: void | import("./types").PreprocessorFn | "none" | "stylis" | undefined;
        stylisMiddleware?: import("./types").StylisMiddleware<import("./types").TemplateStateBase>[] | undefined;
        jsxPreprocessors?: Record<string, import("./types").JSXAttributePreprocessor> | undefined;
        extension?: string | undefined;
        includeBase: boolean;
        includeGlobal: boolean;
        outputPath: string;
        configPath: string;
        configFile?: string | undefined;
    })[][];
};
