"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const plugin_1 = __importDefault(require("./plugin"));
const config_options_1 = require("./config-options");
function isEnabled(caller) {
    return (caller === null || caller === void 0 ? void 0 : caller.name) !== 'linaria' || !caller.evaluate;
}
function default_1(babel, options) {
    if (!babel.caller(isEnabled)) {
        return {};
    }
    return {
        plugins: [
            [
                plugin_1.default,
                Object.assign({ outputPath: options.outputPath || './pages/global.twstyled.css', configPath: options.configPath || './tailwind.config.js', includeBase: options.includeBase !== false, includeGlobal: options.includeGlobal !== false, displayName: process.env.NODE_ENV === 'production' ? false : true, sourceMap: process.env.NODE_ENV !== 'production', evaluate: true, importMap: {
                        styled: ['@twstyled/core', '@linaria/react', 'linaria/react'],
                        css: ['@twstyled/core', '@linaria/core', 'linaria'],
                        tw: ['@twstyled/core']
                    }, rules: [
                        {
                            action: require('@linaria/shaker').default
                        }
                    ] }, config_options_1.getBabelOptions(options))
            ]
        ]
    };
}
exports.default = default_1;
//# sourceMappingURL=index.js.map