"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const babel_preset_1 = require("@linaria/babel-preset");
const visitors_preprocess_1 = __importStar(require("./visitors-preprocess"));
const visitors_write_css_1 = __importDefault(require("./visitors-write-css"));
const visitors_write_css_tailwind_1 = __importDefault(require("./visitors-write-css-tailwind"));
const template_processor_1 = __importDefault(require("./template-processor"));
const stylis_transform_css_tailwind_1 = __importDefault(require("./stylis-transform-css-tailwind"));
const stylis_transform_css_1 = __importDefault(require("./stylis-transform-css"));
function default_1(babel, options) {
    options.templateProcessor =
        options.templateProcessor ||
            babel_preset_1.getTemplateProcessor(babel, options, template_processor_1.default(babel, options));
    options.stylisMiddleware = (options.stylisMiddleware || []).concat([
        stylis_transform_css_tailwind_1.default(babel, options),
        stylis_transform_css_1.default(babel, options)
    ]);
    options.jsxPreprocessors = options.jsxPreprocessors || {
        css: visitors_preprocess_1.getVisitorsPreprocessorJsx(babel, options),
        tw: visitors_preprocess_1.getVisitorsPreprocessorJsx(babel, options)
    };
    const { visitor: visitorLinaria } = babel_preset_1.plugin(babel, options);
    const { visitor: visitorsPrepareTw } = visitors_preprocess_1.default(babel, options);
    const { visitor: visitorWriteCss } = visitors_write_css_1.default(babel, options);
    const { visitor: visitorWriteTwCss } = visitors_write_css_tailwind_1.default(babel, options);
    return {
        visitor: {
            Program: {
                enter(path, state) {
                    state.cssText = '';
                    state.importLocalNames = {};
                    visitorsPrepareTw.Program.enter(path, state);
                    visitorWriteTwCss.Program.enter(path, state);
                    visitorWriteCss.Program.enter(path, state);
                    visitorLinaria.Program.enter(path, state);
                },
                exit(path, state) {
                    visitorLinaria.Program.exit(path, state);
                    visitorWriteCss.Program.exit(path, state);
                    visitorWriteTwCss.Program.exit(path, state);
                    visitorsPrepareTw.Program.exit(path, state);
                }
            }
        }
    };
}
exports.default = default_1;
//# sourceMappingURL=plugin.js.map