"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFile = exports.resolvePath = exports.getHash = void 0;
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const crypto_1 = __importDefault(require("crypto"));
function getHash(source) {
    return crypto_1.default.createHash('md5').update(source).digest('hex');
}
exports.getHash = getHash;
function resolvePath(relativePath, message) {
    try {
        const resolvedConfigPath = path_1.default.resolve(relativePath);
        fs_1.default.accessSync(resolvedConfigPath);
        return resolvedConfigPath;
    }
    catch (err) {
        throw new Error(message !== null && message !== void 0 ? message : `File not found '${relativePath}' | ${err}`);
    }
}
exports.resolvePath = resolvePath;
function getFile(filePath, message) {
    try {
        return fs_1.default.readFileSync(filePath, { encoding: 'utf8' });
    }
    catch (err) {
        throw new Error(message !== null && message !== void 0 ? message : `File not found '${filePath}' | ${err}`);
    }
}
exports.getFile = getFile;
//# sourceMappingURL=general-utils.js.map